

class GaussianPyramid{
 public:
  Image **imgs;
  
  int level;
  int sy,sx;
  
  
  
  
  GaussianPyramid(Image *in){
    int i,j,k;
    sy = in->sy;
    sx = in->sx;
    
    int lx = getlevel(sx);
    int ly = getlevel(sy);
    if(lx<ly){
      level = lx;
    }else{
      level = ly;
    }
    //printf("sy = %d, sx = %d :level = %d\n",sy,sx,level);
    int glevel;
  
    imgs = new Image* [level];
    
    
    int dvy = sy;
    int dvx = sx;
    imgs[0] = in;
    
    for(i=1;i<level;i++){
      
      
      dvy = dvy/2;
      dvx = dvx/2;
      imgs[i] = new Image(dvx,dvy);
      
    }
    
    
    for(i=1;i<level;i++){
      DownSamplingG(imgs[i],imgs[i-1]);
    }
    /*
    for(i=0;i<level-1;i++){
     UpSamplingG(imgs2[i],imgs[i+1]);
   }
    */
        
  }
  

 
  Image *UpSamplingUntilZero(int from){
    int i;
    if(from<=0||from>level)return NULL;
    Image *tmp1 = imgs[from];
    Image *tmp2=NULL;
    Image *tmp3=NULL;
    
    for(i=from;i>0;i--){
      
      tmp2 = Expand(tmp1);
      delete tmp3;
      tmp1 = tmp2;
      tmp3 = tmp2;
    }
    return tmp2;
  
  }
  Image *Expand(Image *in){
    Image *out = new Image(2*in->sx,2*in->sy);
     UpSamplingG(out,in);
    return out;
  
  }
  void UpSampling(Image *out,Image *in){
    int i,j;
    
    for(i=0;i<out->sy;i++)
      for(j=0;j<out->sx;j++){
	
	Expand3(&(out->img[i][j]),i,j,in->img,in->sy,in->sx);
	
      }
    
    
  }
  void UpSamplingG(Image *out,Image *in){
    int i,j;
    
    for(i=0;i<out->sy;i++)
      for(j=0;j<out->sx;j++){
	
	//Expand(&(out->grad[i][j]),i,j,in->grad,in->sy,in->sx);
	Expand(&(out->img[i][j]),i,j,in->img,in->sy,in->sx);
	
	
      }
    
    
  }

  void DownSampling(Image *out,Image *in){
    int i,j;
    

    for(i=0;i<out->sy;i++){
      for(j=0;j<out->sx;j++){

	Reduce3(&(out->img[i][j]),i,j,in->img,in->sy,in->sx);
	
	
      }
    }
  }
    
  void DownSamplingG(Image *out,Image *in){
    int i,j;
    

    for(i=0;i<out->sy;i++){
      for(j=0;j<out->sx;j++){

	//Reduce(&(out->grad[i][j]),i,j,in->grad,in->sy,in->sx);
	
	Reduce(&(out->img[i][j]),i,j,in->img,in->sy,in->sx);
	
		
      }
    }
  }
    
  


  int getlevel(int dx){
    int dv=dx;
    if(dv % 2 !=0)dv--;
    int cnt=0;
    while(1){
      dv /= 2;
      cnt++;
      if(dv==0)break;
    }
    
    return cnt-1;
    
  }

  
  double W(int i,int j){
    
    return what(i)*what(j);
  }
  double what(int i){
    if(i==0){
      return 0.4;
    }else if(i==-1||i==1){
      return 0.25;
    }else{
      //}else if(i==-2||i==2){
      return 0.05;
    }
  }
  
  
  void Reduce3(double *dR,int i,int j,double **inR,int nsy,int nsx){
    double dumR=0.0;
    double dW=0.0;
    int m,n,dm1,dn1,dm2,dn2;
    for(m=-2;m<=2;m++)
      for(n=-2;n<=2;n++){
	dm1 = m;
	dn1 = n;
	dm2 = (2*i+m);
	dn2 = (2*j+n);
	dW = W(dm1,dn1);
	if(dm2==-1){
	  dm2=1;dm1=-dm1;
	}else if(dm2==-2){
	  dm2=2;dm1=-dm1;
	}else if(dm2==nsy){
	  dm2=nsy-1;dm1=-dm1;
	}else if(dm2==nsy+1){
	  dm2=nsy-2;dm1=-dm1;
	}
	if(dn2==-1){
	  dn2=1;dn1=-dn1;
	}else if(dn2==-2){
	  dn2=2;dn1=-dn1;
	}else if(dn2==nsx){
	  dn2=nsx-1;dn1=-dn1;
	}else if(dn2==nsx+1){
	  dn2=nsx-2;dn1=-dn1;
	}
	
	
	dumR += dW*inR[dm2][dn2];
	
	
      }
    (*dR) = dumR;
    
    
  }
  void Reduce(double *dR,int i,int j,double **inR,int nsy,int nsx){
    double dumR=0.0;
    
    double dW=0.0;
    int m,n,dm1,dn1,dm2,dn2;
    for(m=-2;m<=2;m++)
      for(n=-2;n<=2;n++){
	dm1 = m;
	dn1 = n;
	dm2 = (2*i+m);
	dn2 = (2*j+n);
	dW = W(dm1,dn1);
	if(dm2==-1){
	  dm2=1;dm1=-dm1;
	}else if(dm2==-2){
	  dm2=2;dm1=-dm1;
	}else if(dm2==nsy){
	  dm2=nsy-1;dm1=-dm1;
	}else if(dm2==nsy+1){
	  dm2=nsy-2;dm1=-dm1;
	}
	if(dn2==-1){
	  dn2=1;dn1=-dn1;
	}else if(dn2==-2){
	  dn2=2;dn1=-dn1;
	}else if(dn2==nsx){
	  dn2=nsx-1;dn1=-dn1;
	}else if(dn2==nsx+1){
	  dn2=nsx-2;dn1=-dn1;
	}
	
	
	dumR += dW*inR[dm2][dn2];
	
	
      }
    (*dR) = dumR;
    
    
  }


  
  void Expand3(double *dR,int i,int j,double **inR,int nsy,int nsx){
    double dumR=0.0;


    
    double dW=0.0;
    int m,n,dm1,dn1,dm2,dn2;
    for(m=-2;m<=2;m++)
      for(n=-2;n<=2;n++){
	dm1 = m;
	dn1 = n;
	dm2 = (i+m)/2;
	dn2 = (j+n)/2;
	dW = W(dm1,dn1);
	if(dm2==-1){
	  dm2=1;dm1=-dm1;
	}else if(dm2==-2){
	  dm2=2;dm1=-dm1;
	}else if(dm2==nsy){
	  dm2=nsy-1;dm1=-dm1;
	}else if(dm2==nsy+1){
	  dm2=nsy-2;dm1=-dm1;
	}
	if(dn2==-1){
	  dn2=1;dn1=-dn1;
	}else if(dn2==-2){
	  dn2=2;dn1=-dn1;
	}else if(dn2==nsx){
	  dn2=nsx-1;dn1=-dn1;
	}else if(dn2==nsx+1){
	  dn2=nsx-2;dn1=-dn1;
	}
	
	
	dumR += dW*inR[dm2][dn2];
	
	
      }
    (*dR) = dumR;
    
    
  }
 void ExpandOld(double *dR,int i,int j,double **inR,int nsy,int nsx){
    double dumR=0.0;
    double dW=0.0;
    int m,n,dm1,dn1,dm2,dn2;
    for(m=-2;m<=2;m++)
      for(n=-2;n<=2;n++){
	dm1 = m;
	dn1 = n;
	dm2 = (i+m)/2;
	dn2 = (j+n)/2;
	
	//printf("%d %d\n",n,dn2);
	dW = W(dm1,dn1);
	if(dm2==-1){
	  dm2=1;dm1=-dm1;
	}else if(dm2==-2){
	  dm2=2;dm1=-dm1;
	}else if(dm2==nsy){
	  dm2=nsy-1;dm1=-dm1;
	}else if(dm2==nsy+1){
	  dm2=nsy-2;dm1=-dm1;
	}
	if(dn2==-1){
	  dn2=1;dn1=-dn1;
	}else if(dn2==-2){
	  dn2=2;dn1=-dn1;
	}else if(dn2==nsx){
	  dn2=nsx-1;dn1=-dn1;
	}else if(dn2==nsx+1){
	  dn2=nsx-2;dn1=-dn1;
	}
	
	
	dumR += dW*inR[dm2][dn2];
	
	
      }
    (*dR) = dumR;
    
    
  }
 void Expand(double *dR,int i,int j,double **inR,int nsy,int nsx){
    double dumR=0.0;
    double dW=0.0;
    int m,n,dm1,dn1,dm2,dn2;
    int cnt=0;
    /* if((i==128&&j==128)||(i==128&&j==129)||
       (i==129&&j==128)||(i==129&&j==129))       
       printf("(i,j):(%d,%d), ",i,j);*/
    for(m=-2;m<=2;m++){
      if((i+m)%2==0)
      for(n=-2;n<=2;n++){
	dm1 = m;
	dn1 = n;
	if((j+n)%2==0){
	dm2 = (i+m)/2;
	dn2 = (j+n)/2;
	dW = W(dm1,dn1);
	if(dm2==-1){
	  dm2=1;dm1=-dm1;
	}else if(dm2==-2){
	  dm2=2;dm1=-dm1;
	}else if(dm2==nsy){
	  dm2=nsy-1;dm1=-dm1;
	}else if(dm2==nsy+1){
	  dm2=nsy-2;dm1=-dm1;
	}
	if(dn2==-1){
	  dn2=1;dn1=-dn1;
	}else if(dn2==-2){
	  dn2=2;dn1=-dn1;
	}else if(dn2==nsx){
	  dn2=nsx-1;dn1=-dn1;
	}else if(dn2==nsx+1){
	  dn2=nsx-2;dn1=-dn1;
	}
	//cnt++;
	dumR += dW*inR[dm2][dn2];
	/*
	 if((i==128&&j==128)||(i==128&&j==129)||
	    (i==129&&j==128)||(i==129&&j==129)) printf("(m,n):(%d,%d), ((i-m)/2,(j-n)/2):(%d,%d), ",m,n,dm2,dn2);
	*/
      }
      }
    }
    /*
    if((i==128&&j==128)||(i==128&&j==129)||
	    (i==129&&j==128)||(i==129&&j==129))printf("cnt:%d\n",cnt);
    */
    (*dR) = (dumR*4.0);
    
    
  }

  double Reduce(int i,int j,double **in){
    double dum=0.0;
      int m,n,dm1,dn1,dm2,dn2;
      for(m=-2;m<=2;m++)
	for(n=-2;n<=2;n++){
	  dm1 = m;
	  dn1 = n;
	  dm2 = (2*i+m);
	  dn2 = (2*j+n);
	  
	  dum += W(dm1,dn1)*in[dm2][dn2];
	  
	}
      return dum;
  
  }
  double Expand(int i,int j,double **in){
      double dum=0.0;
      int m,n,dm1,dn1,dm2,dn2;
      for(m=-2;m<=2;m++)
	for(n=-2;n<=2;n++){
	  dm1 = m;
	  dn1 = n;
	  dm2 = (i+m)/2;
	  dn2 = (j+n)/2;
	  dum += W(dm1,dn1)*in[dm2][dn2];
	}
      return (4.0*dum);
  }
  

  virtual ~GaussianPyramid(){
    int i;
    for(i=1;i<level;i++){
      delete imgs[i];
      
      
      
    }
    
    delete [] imgs;
    
     
  }

  
  
  
 private:
   GaussianPyramid(const GaussianPyramid& rhs);
  const GaussianPyramid &operator=(const GaussianPyramid& rhs);

};
